#ifndef __csvreader__
#define __csvreader__

#include <fstream>
#include <string>
#include <error.hpp>

using namespace std;

class CSVReader
{
private:

ifstream
   clFile;

string
   clLine;

string
   clNextLine;

string
   clDelimiter;

string
   clHeadLine;

bool
   clHasHeadLine;

int
   clNumFields;

int
   countFields(string &row);

string
   _getField(string &row, int fieldNum)
      throw(Error);

public:

CSVReader(string file, string clDelimiter, bool hasHeadLine)
   throw(Error);

~CSVReader();

bool
   hasHeadLine();

bool
   hasNext();

void
   next();

int
   getNumFields();

string
   getHeadLine()
      throw(Error);

string
   getLine()
      throw(Error);

string
   getField(int fieldNum)
      throw(Error);

string
   getHeadField(int fieldNum)
      throw(Error);
};

#endif
