#include <splitter.hpp>
#include <iostream>

Splitter :: Splitter
 (
   CSVReader *reader
 )
   throw(Error)
{
   clReader = reader;
}

Splitter :: ~Splitter()
{
   delete clReader;
}

void Splitter :: split
 (
   int groupField,
   string outDir
 )
   throw(Error)
{
   map<string, fstream *> groupToFile;

   while (clReader->hasNext())
   {
      clReader->next();

      string group = clReader->getField(groupField);
      string lineLn = clReader->getLine() + "\n";

      cout << lineLn;

      fstream *appendFile;

      map<string, fstream *>::iterator foundFile = groupToFile.find(group);
      if (foundFile == groupToFile.end())
      {
         string appendFileName = outDir + "/" + group;

         appendFile = new fstream(appendFileName.c_str(), ios::trunc | ios::out);

         if (! appendFile->good())
         {
            throw Error("Could not create file: " + appendFileName);
         }

         groupToFile.insert(pair<string, fstream *>(group, appendFile));
         
         if (clReader->hasHeadLine())
         {
            appendFile->write((clReader->getHeadLine() + "\n").c_str(), clReader->getHeadLine().size() + 1);
         }
      }
      else
      {
         appendFile = foundFile->second;
      }

      cout << "appending: " << lineLn;
      appendFile->write(lineLn.c_str(), lineLn.size());
   }

   cout << groupToFile.size() << endl;

   for (map<string, fstream *>::const_iterator it = groupToFile.begin(); it != groupToFile.end(); ++it)
   {
      cout << "clozing" << endl;
      it->second->flush();
      it->second->close();
      delete it->second;
   }
}
